--[[
	The class for all game states
	Caveware Digital :: 2017
]]


local Levels = {}
Levels.__index = Levels

--[[
	Create a game state
	OUTPUT: The newly created game state
]]
function Levels:load(option)
	local level = {}
	setmetatable(level, self)

	level.list = {
		"/assets/maps/test",
		"/assets/maps/test2"
	}
	level.option = option
	--level.level = level.list[option]

	level.enemies = {}
	level.noise_makers = {}
	level.player_start = {}
	level.door = {}
	level.ducky = {}
	return level
end

function Levels:getMap()
	return self.list[self.option]
end
function Levels:lastMap()
	if self.option >= #self.list then
		return true
	end
	return false
end

function Levels:getProperties()
	return {
		player_start = self.player_start,
		ducky_pos = self.ducky,
		door_pos = self.door,
		enemy_list = self.enemies,
		noise_list = self.noise_makers,
	}
end

function Levels:makeLevel()
	if self.option == 1 then
		self:makeLevelOne()
	elseif self.option == 2 then
		self:makeLevelTwo()
	end
end

function Levels:makeLevelOne()
	self.player_start = {x = 400, y = 100}
	self.ducky = {x = 200, y = 200}
	self.door = {x = 400, y = 400}
	self:makeEnemy(10,10, 100, 100)
	self:makeEnemy(200, 200, 400, 300)
	self:makeNoise(250, 250)

end

function Levels:makeLevelTwo()
	self.player_start = {x = 300, y = 300}
	self.ducky = {x = 200, y = 200}
	self.door = {x = 400, y = 400}
	self:makeEnemy(10,10, 100, 100)
	self:makeEnemy(200, 200, 400, 300)
	self:makeEnemy(100, 400, 100, 400)
	self:makeNoise(250, 250)

end

function Levels:makeEnemy(x,y,dest_x,dest_y)
	local enemy = {}
	enemy = {x = x, y = y, dest_x = dest_x, dest_y = dest_y}
	table.insert(self.enemies, enemy)
end
function Levels:makeNoise(x,y)
	local noise = {}
	noise = {x = x, y = y}
	table.insert(self.noise_makers, enemy)
end

--[[
	Performed to draw the game state
]]
function Levels:draw() end


function Levels:update(dt) end


return Levels
