--[[
	The class for all game states
	Caveware Digital :: 2017
]]


local Learn = {}
Learn.__index = Learn


--[[
	Create a game state
	OUTPUT: The newly created game state
]]
function Learn:new()
	local game_state = {}
	setmetatable(game_state, self)
	return game_state
end


--[[
	Performed to draw the game state
]]
function Learn:draw()
	love.graphics.draw(gfx.HowToPlay, 0, 0)
	local subtitle = "Press Enter to begin"
	love.graphics.setColor(255, 255, 10)
	love.graphics.setFont(love.graphics.setNewFont(20))
	love.graphics.printf(subtitle,  love.graphics.getWidth()/2, (love.graphics.getHeight())-50, love.graphics.getWidth()/2, "center")
end


--[[
	Performed when the game state is paused
]]
function Learn:pause() end


--[[
	Performed when the game state is resumed
]]
function Learn:resume() end


--[[
	Performed to start the game state
]]
function Learn:start(options) end


--[[
	Performed to destroy the game state (eg. moving from level-to-level)
]]
function Learn:stop() end


--[[
	Performed to update the game state (each step it's active)
]]
function Learn:update(dt)
	local input = InputManager
	if input:wasPressed("action") then
		StateManager:push("game", 1)
	end
end


return Learn
