--[[
	The class for all game states
	Caveware Digital :: 2017
]]


local MainMenu = {}
MainMenu.__index = MainMenu


--[[
	Create a game state
	OUTPUT: The newly created game state
]]
function MainMenu:new()
	local game_state = {}
	setmetatable(game_state, self)
	return game_state
end



--[[
	Performed to draw the game state
]]
function MainMenu:draw()
	love.graphics.setColor(ColorTool:get("lightgrey"))
	love.graphics.draw(gfx.Title, 0, 0)
	local subtitle = "Press Enter to begin"
	love.graphics.setFont(love.graphics.setNewFont(12))
	love.graphics.printf(subtitle, 0, (love.graphics.getHeight()/ 2) + 40, love.graphics.getWidth(), "center")
	local subtitle = "Press Shift to Learn How to Play"
	love.graphics.setFont(love.graphics.setNewFont(12))
	love.graphics.printf(subtitle, 0, (love.graphics.getHeight()/ 2) + 80, love.graphics.getWidth(), "center")
end

--[[
	Performed when the game state is paused
]]
function MainMenu:pause() end


--[[
	Performed when the game state is resumed
]]
function MainMenu:resume() end


--[[
	Performed to start the game state
]]
function MainMenu:start(options)
	bgm.menuloop1:play()
end


--[[
	Performed to destroy the game state (eg. moving from level-to-level)
]]
function MainMenu:stop()
end


--[[
	Performed to update the game state (each step it's active)
]]
function MainMenu:update(dt)
	local input = InputManager
	if input:wasPressed("action") then
		StateManager:push("game", 1)
		bgm.menuloop1:stop()
	end
	if input:wasPressed("shift") then
		StateManager:push("learn")
		bgm.menuloop1:stop()
	end



end


return MainMenu
