--[[
	The class for all game states
	Caveware Digital :: 2017
]]


local GameState = {}
GameState.__index = GameState


--[[
	Create a game state
	OUTPUT: The newly created game state
]]
function GameState:new()
	local game_state = {}
	setmetatable(game_state, self)
	return game_state
end


--[[
	Performed to draw the game state
]]
function GameState:draw() end


--[[
	Performed when the game state is paused
]]
function GameState:pause() end


--[[
	Performed when the game state is resumed
]]
function GameState:resume() end


--[[
	Performed to start the game state
]]
function GameState:start(options) end


--[[
	Performed to destroy the game state (eg. moving from level-to-level)
]]
function GameState:stop() end


--[[
	Performed to update the game state (each step it's active)
]]
function GameState:update(dt) end


return GameState
