--[[
	The class for all game states
	Caveware Digital :: 2017
]]


local WinState = {}
WinState.__index = WinState


--[[
	Create a game state
	OUTPUT: The newly created game state
]]
function WinState:new()
	local win_state = {}
	setmetatable(win_state, self)
	return win_state
end


--[[
	Performed to draw the game state
]]
function WinState:draw()
	love.graphics.setBackgroundColor(ColorTool:get("white"))
	love.graphics.draw(AssetManager:getFromPath("/gfx/rubber_ducky.png"), 20, 20, 0.5, 0.5)
	love.graphics.setColor(200, 150, 10)
	love.graphics.print("YOU'RE WINNER", 250, 250)
end


--[[
	Performed when the game state is paused
]]
function WinState:pause() end


--[[
	Performed when the game state is resumed
]]
function WinState:resume() end


--[[
	Performed to start the game state
]]
function WinState:start(options) end


--[[
	Performed to destroy the game state (eg. moving from level-to-level)
]]
function WinState:stop() end


--[[
	Performed to update the game state (each step it's active)
]]
function WinState:update(dt) end


return WinState
