--[[ Particle physics handler written for GGJ2k17
Caveware.Digital]]

local Physics = {}


function Physics:load() -- loading the walls
	for key, wall in ipairs(walls) do
		if wall.shape == "rectangle" then
			wall.body	= lp.newBody(world, wall.x - wall.w / 2, wall.y - wall.h / 2)
			wall.shape	= lp.newRectangleShape(wall.w, wall.h)
			wall.fixture = lp.newFixture(wall.body, wall.shape)
		elseif wall.shape == "polygon" then
			wall.body	= lp.newBody(world, wall.x - 16, wall.y - 16)
			wall.shape	= lp.newPolygonShape(wall.vertices)
			wall.fixture = lp.newFixture(wall.body, wall.shape)
			wall.fixture:setUserData("wall")
		end
	end
end

function Physics:update()
	contacts = World:getContactList()
	local fixtures = {}
	for key, contact in ipairs(contacts) do
		local fixtureA, fixtureB = contact:getFixtures()
		table.insert(fixtures, fixtureA)
		table.insert(fixtures, fixtureB)
	end

	for key, fixture in ipairs(fixtures) do
		local body = fixture:getBody()
		local type = body:getType()
		if type == "particle" then
			local vx, vy = fixture:getLinearVelocity()
			

	end
end


return Physics
