--[[
	<Insert description of game here>
	Caveware Digital :: 2017
]]


if (Flags.GAME_PIXEL_BASED) then
	love.graphics.setDefaultFilter('nearest')
end


require("libs")
require("extensions")
require("entities")
require("helpers")
require("assets")


--[[
	Loads the initial game state
]]
function love.load()
	InputManager:load()
	ScaleManager:load()
	World = love.physics.newWorld(0, 0)
	World:setCallbacks(beginContact)
	lp.setMeter(32)


	-- Add the splash screen as the first state
	StateManager:push("splash", {
		next_state = "mainmenu"
	})


end


function love.update(dt)
	require("libs/lovebird"):update()

	-- Update Lovebird if in development mode (and get FPS)
	if (Flags.DEVELOPMENT) then
		lovebird.update()
		fps = love.timer.getFPS
	end

	-- Limit FPS lower limit to 15 to save calculations
	dt = math.min(dt, 1 / 15)

	InputManager:update()

	-- Updates all timers
	TimerManager:update(dt)

	-- Update the current state
	StateManager:update(dt)

	World:update(dt)


end


function love.draw()

	-- Draw the current state
	ScaleManager:draw(function ()
		StateManager:draw()
	end)
	love.graphics.setColor{ 255, 0, 0}
	if fps then love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
	end
end



function love.keypressed(key)
	if key == "escape" then
		love.event.quit()
	end
end
